const env = process.env.NODE_ENV;
const isBuild=process.env.IS_BUILD;

//note 设置项目子目录路径
const baseURL= env=="test" || env=="local" || env=="localTest" || env=="development" || env=="uat"?'/zdpyc/portal/': "/";
// const baseURL='/';
//note 接口访问地址前缀
//如果和域名加二级目录不一致则需要设置prefix,否则只需要设置baseURL
const prefix='';

// 兼容ie10不认识location.origin
if (!window.location.origin) {
  window.location.origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port: '');
}
// note 一网
const envURL = {
  production: 'http://39.106.250.141:8080',
  uat: 'http://39.97.6.213:8001',
  test: 'http://yangwei.tydicdev.com',
  // test: 'http://39.107.157.8:8080',
  development: 'http://yangwei.tydicdev.com:801',
  local: 'http://yangwei.tydicdev.com:801',
  // localTest: 'http://39.107.157.8:8080',
  localTest: 'http://yangwei.tydicdev.com',
};
// note 一码扫码
const qcodeURL = {
  production: 'http://39.107.158.56:8080/generateCode/generateQrcode?content=',
  uat: 'http://39.97.6.213:8001/generateCode/generateQrcode?content=',
  test: 'http://yangwei.tydicdev.com/zdpyc/portal/generateCode/generateQrcode?content=',
  // test: 'http://39.107.157.8:8080/generateCode/generateQrcode?content=',
  development: 'http://60.205.124.226:8080/generateCode/generateQrcode?content=',
  local: 'http://60.205.124.226:8080/generateCode/generateQrcode?content=',
  localTest: 'http://101.201.31.215:8080/generateCode/generateQrcode?content=',
};
// note 一码获取内容
const qcodeContent = {
  production: 'http://39.107.158.56:8080/?projId=',
  uat: 'http://60.205.124.226:8080/?projId=',
  test: 'http://yangwei.tydicdev.com/zdpyc/portal/zdpyc/scan/?projId=',
  // test: 'http://39.107.157.8:8080/zdpyc/scan/?projId=',
  development: 'http://60.205.124.226:8080/?projId=',
  local: 'http://60.205.124.226:8080/?projId=',
  localTest: 'http://101.201.31.215:8080/?projId=',
};
// note 智能客服
const customURL = {
  production: 'http://zwfw.xa.gov.cn/zdpyc/ics',
  uat: 'http://39.97.6.213:8005',
  test: 'http://yangwei.tydicdev.com/zdpyc/ics',
  development: 'http://47.95.29.235:8080',
  local: 'http://47.95.29.235:8080',
  localTest: 'http://47.95.29.235:8080',
};

//note 路由白名单 此名单路由优先不拦截
const whiteList = {
  production: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-hand-guide/
  ],
  uat: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-hand-guide/
  ],
  test: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-hand-guide/
  ],
  development: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-hand-guide/
  ],
  local: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-procceeds-template-single-index/
  ],
  localTest: [
    /home-procceeds-list/,
    /home-legal-identiy/,
    /home-procceeds-template-single-index/
  ]
};
//note 路由黑名单 此名单路由拦截
const blackList = [
  /home-legal/,
  /home-member/,
  /home-procceeds/,
  /home-fast-register/,
  /home-hand-guide/
];
//note 回调地址黑名单 此名单地址回调为首页
const callBacBlackList = [
  /home-fast-regisiter/,
  /home-personal/,
  /home-find-pwd/,
  /home-legal/,
  /home-procceeds-template-single-index/
];
//note 第三方登录未认证白名单 此名单内路由不会跳转至第三方登录认证页面
const authoWhiteList = [
  /home-personal-create-account/,
  /home-personal-real-name/,
  /home-personal-finish/
];

//note 智能客服地址
function getCustomURL() {
  return customURL[env];
}

//note 事项二维码地址
function getQcodeURL() {
  return qcodeURL[env];
}
//note 获取二维码内容地址
function getQcodeContent() {
  return qcodeContent[env];
}
//note 获取环境地址
function getEnvURL() {
  if(isBuild==='true'){
    console.log('isBuild:'+isBuild,'url:'+location.origin + baseURL);
    return location.origin + baseURL;
  }else{
    console.log('isBuild:'+isBuild,'url:'+envURL[env]);
    return envURL[env]+ baseURL;
  }
};
const config = {
  env: env,
  //note 设置项目子目录路径
  baseURL:baseURL,
  //note mock地址
  mock_uri: 'http://39.107.52.108:8001/app/mock/30/',
  //note 登录地址
  loginUrl() {
    let result = false;
    const path = location.href
    callBacBlackList.forEach(item => {
      if (path.match(item)) {
        result = true;
      }
    });
    if (result) {
      return getEnvURL()+'' + 'casRoute/skip?callBackUrl=' + location.origin+baseURL;
    }
    return getEnvURL() + 'casRoute/skip?callBackUrl=' + location.href;
  },
  loginTarget: '_self',
  // loginTarget: env === 'production' ? '_self' : '_self',
  // target: env === 'production' ? '_self' : '_blank',
  //note 退出地址
  logoutUrl: `${getEnvURL()}logout`,
  logoutTarget: env === 'production' ? '_self' : '_blank',
  //note 智能客服地址
  customURL: customURL[env],
  //note 事项二维码地址
  qcodeURL: qcodeURL[env],
  qcodeContent: qcodeContent[env],
  //note 接口基础路径
  apiBaseUrl: getEnvURL(),
  //note 接口前缀
  prefix: prefix,
  //note 白名单
  inList(path, whiteOrBlack) {
    let result = false;
    whiteOrBlack.forEach(item => {
      if (path.match(item)) {
        result = true;
      }
    });
    return result;
  },
  inWhite(path) {
    return this.inList(path, whiteList[env])
  },
  inBlack(path) {
    return this.inList(path, blackList)
  },
  inAuthorWhite(path) {
    console.log('authorList:', path)
    console.log('是否第三方登录未认证白名单:', this.inList(path, authoWhiteList))
    return this.inList(path, authoWhiteList)
  },
  //note 二维码
  qrCode(id) {
    return getQcodeURL() + encodeURI(getQcodeContent() + `${id}`)
  },
  //note 获取环境地址
  getEnvURL:getEnvURL,
  api(service, type, mock = false) {
    if (service.match(/^((http|https|file)?):\/\/([\w\-]+(\.[\w\-]+)*\/)*[\w\-]+(\.[\w\-]+)*\/?(\?([\w\-\.,@?^=%&:\/~\+#]*)+)?/)) {
      return service;
    }
    if (mock) {
      return `${this.mock_uri}${type || service}`;
    }
    switch (type) {
      case 'menu':
        return this.apiBaseUrl + 'pages/user/menus';
      case 'upload':
        return this.apiBaseUrl + 'file/upload'
      case 'down':
        return this.apiBaseUrl + 'rest/download' + service
      default:
        return this.apiBaseUrl + this.prefix + service
    }
  },
}
export default config
